'###########################################################################################################################################################
'Beispiel VBSkript fr die Ethernet I/O-Karte "MFC 8800-DC/EM-LAN" der Fa. Intronico GmbH
'
'Author: Michael Zrch, MELA Sensortechnik GmbH
'Datum : 05.10.2006
'
'Verwendete Hardware  : MFC 8800-DC/EM-LAN Version 1.50, alle Einstellungen wie ab Werk (nur IP fest gesetzt)
'Standardeinstellungen: Port: 2101  Passwort:1234  
'
'Aufrufbeispiel: mfc8800.vbs ip:192.168.0.215 port:2101 pass:1234 on:0 off:1
'Erklrung     :
'                ip:   - legt die IP-Adresse bzw. Hostname des MFC8800 fest
'                port: - legt den verwendeten Port fest (Standard: 2101)
'                pass: - legt das Passwort fest (Standard: 1234)
'                on:0  - Schliet Relais 1
'                off:1 - Schliet Relais 2
'
'Man kann also alle notwendigen Parameter als Kommandozeile bergeben. Mit on:<Nr> wird Relais <Nr+1> geschlossen, mit off:<Nr> wird Relais <Nr+1> geffnet.
'Die jeweils nicht erwhnten Anschlsse werden nicht gendert.
'
'Es erfolgt keine Rckmeldung ber Erfolg oder Misserfolg der bertragung!
'
'VBSkript muss installiert sein. 
'
'Man lese das App.Note 1 fr mehr Informationen
'
'Lesen Sie die Anleitung zum MFC8800! MELA Sensortechnik bernimmt kein Haftung fr Schden, die durch dieses Skript entstehen.
'
'
'
'ACHTUNG: Bevor dieses Skript funktioniert muss ToolsackBaseline11.msi einmalig ausgefhrt werden. Dabei wird u.a. der bentigte 
'         TCP/IP-Socket installiert. Beachten Sie die Lizenzinformation in ToolsackBaseline11.msi.
'
'         Thanks to http://www.toolsack.com
'
'
'
'2006 (c) MELA Sensortechnik GmbH, Alle Rechte vorbehalten.
'###########################################################################################################################################################

'Variablen festlegen
Dim TmrTimeout
Dim IP
Dim Port
Dim Pass
Dim Commands()
Dim CommandCount
Dim i

'WinSock-Steuerelement laden
Set Socket = CreateObject("Toolsack.Socket")
'Kommandozeile abfragen
Set ArgObj = WScript.Arguments

'Variablen initialisieren
CommandCount = 0
IP = ""
Port = 2101 'Standardport verwenden, falls kein Port bergeben wird

'Schleife, alle Kommandozeilenparameter auswerten
For i = 1 to ArgObj.count
	
	'IP-Adresse auslesen
	If Left(ArgObj.item(i-1),2) = "ip" then
		IP = Right(ArgObj.item(i-1),Len(ArgObj.item(i-1))-3)
	End if

	'Portnummer auslesen
	If Left(ArgObj.item(i-1),4) = "port" then
		Port = CLng(Right(ArgObj.item(i-1),Len(ArgObj.item(i-1))-5))
	End if

	'Passwort auslesen
	If Left(ArgObj.item(i-1),4) = "pass" then
		Pass = Right(ArgObj.item(i-1),Len(ArgObj.item(i-1))-5)
	End if

	'Steuerkommandos on/off auslesen uns listen
	If Left(ArgObj.item(i-1),2) = "on" or Left(ArgObj.item(i-1),3) = "off"  then
		CommandCount = CommandCount + 1 'Kommandozhler erhhen
		ReDim Preserve Commands(CommandCount) 'Kommandoarray vergrern
		Commands(CommandCount) = ArgObj.item(i-1) 'Kommandoarray schreiben
	End if
Next

'Falls eine notwendige Information fehlt, dann Abbruch
If IP = "" then 
	WScript.quit
End if
If Port = 0 then 
	WScript.quit
End if
If CommandCount = 0 then 
	WScript.quit
End if


'Timeout Zhler initialisieren 
TmrTimeout = Timer

'Socket-Steuerlement verbinden mit IP auf Port
Socket.Connect IP,Port

'Warteschleife, warten bis Verbindung steht
Do 
	If TmrTimeout + 3 < Timer then 'Nach 3 Sekunden Abbruch, falls keine erfolgreiche Verbindung
		Socket.close	'Socket schlieen
		WScript.quit	'Skript beenden
	End if

	WScript.sleep 100

Loop until Socket.IsConnected
'Schleife durchlaufen bis Verbindung hergestellt wurde

'Login senden
Socket.Write "login:" + Pass + VbCr
WScript.sleep 100

'Kommandos zum sezten der Relais senden
For i = 1 to CommandCount
	Socket.Write Commands(i) + VbCr
	WScript.sleep 100
Next

'Logout senden
Socket.Write "logout:" + VbCr
WScript.sleep 100

'Verbindung schlieen
Socket.close

WScript.quit